Subject: Re: [PATCH v3 0/2] Improve handling of stage 2 aborts without instruction decode

From: Marc Zyngier <[email-masked]>
Date: Sun, 20 Oct 2019 11:25:24 +0100

Hi Christoffer,

On Fri, 11 Oct 2019 12:07:04 +0100,
Christoffer Dall <[email-masked]> wrote:
> 
> When a guest accesses memory outside the memory slots, KVM usually
> bounces the access back to userspace with KVM_EXIT_MMIO.  However, on
> arm/arm64 systems, certain load/store instructions did not provide
> decoding info for the hypervisor to emulate the instruction, and in this
> case KVM has rather rudely returned -ENOSYS and printed a not overly
> helpful error message:
> 
>   load/store instruction decoding not implemented
> 
> This patch series improves the error message and allows userspace to be
> notified of this event instead of receiving -ENOSYS, and also allows
> userspace to ask KVM to inject an external abort to the guest, which it
> can use for any memory access that it either cannot handle.
> 
> One remaining case which this patch set does not address is if the guest
> accesses an in-kernel emulated device, such as the VGIC, but using a
> load/store instruction which doesn't provide decode info.  With these
> patches, this will return to userspace for it to handle, but there's no
> way for userspace to return the decoding information to KVM and have KVM
> complete the access to the in-kernel emulated device.  I have no plans
> to address this limitation.

You had some pending comments on patch 2, and you seem to indicate
that you would respin the series. Do you have plans to do so in the
coming days? I'd like to put that series into -next, but I can either
wait for your respin, or queue it as it is and apply fixes on top.

Please let me know what you prefer.

Thanks,

	M.

-- 
Jazz is not dead, it just smells funny.

_______________________________________________
linux-arm-kernel mailing list
[email-masked]
http://lists.infradead.org/mailman/listinfo/linux-arm-kernel